------------------------------------------------------------------------
--
-- t@C : patterngen.vhd
-- @\       : p^[W[
--              16NbN̊ԂɔCӉ񐔃gOM𐶐
-- XV   : 2006/11/11 - ver 1.0  
--
-- Copyright(C)2006 K.Ochiai. All rights reserved.
--
------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

-------------------------
-- GeBeB
-------------------------
entity patterngen is
port(
		CLK		: in std_logic;						-- NbN
		CKE		: in std_logic;						-- NbNECl[u
		RST		: in std_logic;						-- 񓯊Zbg
		TRATE	: in std_logic_vector(7 downto 0);	-- gO
		POUT	: out std_logic						-- p^[o
);
end patterngen;

-------------------------
-- A[LeN`
-------------------------
architecture rtl of patterngen is
-- WX^/M`
signal counter	: integer range 0 to 15;			-- JE^(JEg0`15܂)

-- A[LeN`{
begin
	-- JE^
	process(CLK,RST)
	begin
		if(RST = '1') then							-- Zbg
			counter <= 0;
		elsif(CLK'event and CLK = '1') then			-- NbNオ蓯
			if(CKE = '1') then						-- @NbNECl[u'1'̂Ƃȉ̉H삷
				if(counter = 15) then
					counter <= 0;					-- őJEgȂNA
				else
					counter <= counter + 1;			-- ȊOȂCNg
				end if;
			end if;
		end if;
	end process;

	-- p^[
	--   JEgƂTRATE̊erbgo͂DJEg̎'0'o͂D
    --   TRATE1rbgEZbg邲ƂɁC16NbÑgO2񑝂D
    --   ăgO0`100܂12.5݂ŉςłD
	POUT <= TRATE(7) when counter = 0 else
			TRATE(6) when counter = 2 else
			TRATE(5) when counter = 4 else
			TRATE(4) when counter = 6 else
			TRATE(3) when counter = 8 else
			TRATE(2) when counter = 10 else
			TRATE(1) when counter = 12 else
			TRATE(0) when counter = 14 else '0';

end rtl;
