//----------------------------------------------------------------------
//
// t@C : loadmod.v
// @\       : ׃W[ Verilog
//              4rbgCftHg2048i̐[pCvC
//              \d͂҂
// XV   : 2006/11/16 - ver 1.0  
//
// Copyright(C)2006 K.Ochiai. All rights reserved.
//
//----------------------------------------------------------------------

module loadmod(CLK,CKE,RST,LOAD,LDATA,PIN,TDETECT);
	// 萔`
	parameter		DEPTH = 2048;	// pCvC[
	
	// o͐M`
	input			CLK;		// NbN
	input			CKE;		// NbNECl[u
	input			RST;		// 񓯊Zbg
	input			LOAD;		// [hM
	input [3:0]		LDATA;		// [hEf[^
	input			PIN;		// ĩp^[
	output			TDETECT;	// gOo

	// WX^`
	reg [DEPTH-1:0]	reg0; 		// pCvCErbg0
	reg [DEPTH-1:0]	reg1; 		// pCvCErbg1
	reg [DEPTH-1:0]	reg2; 		// pCvCErbg2
	reg [DEPTH-1:0]	reg3; 		// pCvCErbg3
	reg [1:0]		regsft;		// gOopVtgWX^
	
	// ϐ`
	integer			i;			// JԂLqp

	// ׃ubN(pCvC)
	always @(posedge CLK or posedge RST) begin
		if(RST) begin							// 񓯊Zbg
			for(i=0 ; i<DEPTH ; i=i+1) begin
				reg0[i] <= 1'b0;
				reg1[i] <= 1'b0;
				reg2[i] <= 1'b0;
				reg3[i] <= 1'b0;
			end
		end else if(CKE) begin					// NbNECl[u'1'̂Ƃȉ̉H삷
			if(LOAD) begin						// [h
				reg0[0] <= LDATA[0];			//   H̍œKɂpCvCk}~邽߂
				reg1[0] <= LDATA[1];			//   [h@\tĂD@\͎̂gȂ̂ŁC
				reg2[0] <= LDATA[2];            //   {[h̖gp[qɐM蓖āCFPGÃEB[NE
				reg3[0] <= LDATA[3];			//   vAbvŔANeBuɌŒ肷D
			end else begin
				reg0[0] <= PIN;					// pCvCiւ̃p^[
				reg1[0] <= PIN;
				reg2[0] <= PIN;
				reg3[0] <= PIN;
			end

			// pCvC
			//   \[Xgpグ邽߁CtbvEtbvO4LUTKt悤Ș_ɂĂD
			//   ܂œKh߁Cerbg̘_͏ςĂD[h͎g킸Ci
			//   Mׂ͂ēȂ̂ŁĈ͂̃VtgWX^Ƃē삷D
			for(i=1 ; i<DEPTH ; i=i+1) begin
				reg0[i] <= ( reg0[i-1] &  reg1[i-1] &  reg2[i-1] &  reg3[i-1]) |
				           (~reg0[i-1] &  reg1[i-1] & ~reg2[i-1] &  reg3[i-1]);
				reg1[i] <= ( reg0[i-1] &  reg1[i-1] &  reg2[i-1] &  reg3[i-1]) |
				           ( reg0[i-1] & ~reg1[i-1] & ~reg2[i-1] &  reg3[i-1]);
				reg2[i] <= ( reg0[i-1] &  reg1[i-1] &  reg2[i-1] &  reg3[i-1]) |
				           (~reg0[i-1] &  reg1[i-1] &  reg2[i-1] & ~reg3[i-1]);
				reg3[i] <= ( reg0[i-1] &  reg1[i-1] &  reg2[i-1] &  reg3[i-1]) |
				           ( reg0[i-1] & ~reg1[i-1] &  reg2[i-1] & ~reg3[i-1]);
			end
		end
	end

	// gOo
	always @(posedge CLK or posedge RST) begin
		if(RST) begin							// 񓯊Zbg
			regsft <= 2'b00;
		end else begin
			regsft[0] <= reg3[DEPTH-1] & reg2[DEPTH-1] & reg1[DEPTH-1] & reg0[DEPTH-1];
			regsft[1] <= regsft[0];
		end
	end

	// pCvCŏIi̗オ/藼GbWoďo͂
	assign TDETECT = ((regsft == 2'b10) || (regsft == 2'b01)) ? 1'b1 : 1'b0;

endmodule
